Delaunay Triangulation in OpenCascade

Delaunay Triangulation in
OpenCascade

eryar@163.com

摘要:本文简要介绍了Delaunay三角剖分的基础理论,并接纳OpenCascade的三角剖分算法将边界BRep表示的几何体举办三角离散化后在OpenSceneGraph中呈现。 

关键字:Delaunay Triangulation、OpenCascade、OpenSceneGraph 

一、 概述

三角形剖分是平面剖分中的一个首要课题,在数字图像处理、统计机三维曲面造型、有限元总结、逆向工程等领域拥有广泛应用。由于三角形是平面域中的单纯形,与其它平面图形相相比较,其有描述方便、处理大概等特色,很适合于对复杂区域拓展简化处理。由此,无论在总计几何、总计机图形处理、形式识别、曲面逼近,还有个别元网格生成地点有周边的利用。 

虽然曲线、曲面等有规范的方程来表示,不过在在总结机中,只可以用离散的办法来逼近。如曲线可用直线段来逼近,而曲面可用多边形或三角形来代表。用多边形网格表示曲面是规划中时常应用的花样,可以按照使用要求拔取网格的密度。利用三角形面片表示的曲面在处理器图形学中也称之为三角形网格。用三角网格表示曲面需要解决多少个问题:三角形的暴发、描述、遍历、简化和减弱等,这么些题目都是精打细算几何研商的层面,相关问题都足以从中找到答案。下图所示的圆柱和立方体是由OpenCascade生成,使用OpenCascade的算法离散成三角网格后在OpenSceneGraph中呈现的效率。 

考古学 1

Figure 1.1 Shaded Cylinder and Box 

考古学 2

Figure 1.2 Mesh generated by OpenCascade 

从图中可以看到,平面的三角形网格效率还不易,曲面的三角网格表示只可以是类似表示,可以透过加强网格的密度来充实真实性,但对应渲染的数据量就大了。有人说OpenCascade的呈现模块做得不是很好,上述办法则足以只利用OpenCascade的形态模块,再结合OpenSceneGraph来对图片举办体现。 

三维数据互换STL格式文件中保留的都是三角面片的数码,STL文件格式是由花旗国3D
System公司开发,已被工业界认为是眼下很快机动成型领域的准标准零件描述文件格式。它对三维实体描述的表达具有惟一性。几乎所有的几何样子系统都提供STL文件数据互换接口。OpenCascade中的数据互换模块也提供对STL格式的支撑,综上可得三角网格在几何样子系统中的首要性。 

Voronoi图和Delaunay三角剖分的应用领域相当普遍:几何建模——用来寻找三维曲面“好的”三角剖分;有限元分析——用来变化“好的”有限元网格;地理信息体系——用来开展空间领域分析;结晶学——用来规定合金的构造;人类学和考古学——用来确定氏族部落、首领权威、居住中央或堡垒等的震慑范围;天管教育学——用来确定恒星和星系的分布;生物学生态学和林学——用来规定动植物的竞争;动物学——分析动物的领地;总括学和数据解析——用来分析计算聚合;机器人学——用来举办移动轨迹规划(在存在障碍物的景观下);格局识别——作为寻找物体骨架点的工具;生教育学——用来分析毛细效能的领域;气象学——用来打量区域平均降雨量;市场学——用来树立城市的市场辐射范围;以及在遥感图像处理、化学、地农学、地质学、冶金学、数学等科目的利用等。 

正文只对OpenCascade中的三角剖分举行简单介绍,希望对三角剖分在三维几何样子方面有趣味的爱侣可以对其深远钻研。水平很单薄,文中不当之处欢迎批评指正、指引,联系邮箱:eryar@163.com。 

二、 Voronoi图

Dirichlet于1850年探究了平面点的邻域问题,Voronoi于1908年将其结果扩充到高维空间。半空间定义Voronoi图:给定平面上n个点集S,S={p1,
p2, …, pn}。定义: 

考古学 3

PiPj连线的垂直平分面将空间分为两半,V(Pi)表示比其他点更接近Pi的点的轨道是n-1个半平面的交,它是一个不多于n-1条边的凸多边形域,称为关联于Pi的Voronoi多边形或涉及于Pi的Voronoi域。如下图所示为关联于P1的Voronoi多边形,它是一个四边形,而n=6. 

考古学 4

Figure 2.1 n=6时的一种V(p1) 

对此点集S中的每个点都得以做一个Voronoi多边形,这样的n个Voronoi多边形组成的图称为Voronoi图,记为Vor(S)。如下图所示: 

考古学 5

Figure 2.2 Voronoi diagram for 10 randomly points (Generated by MATLAB) 

图中的顶点和边分别名为Voronoi顶点和Voronoi边。显著,|S|=n时,Vor(S)划分平面成n个多边形域,每个多边形域V(Pi)包含S中的一个点同时只含有S中的一个点,Vor(S)的边是S中某点对的垂直平分线上的一条线条或半直线,从而为该点对所在的六个多边形域所共有。Vor(S)中有的多边形域是无界的。 

考古学 6

Figure 2.3 Ten shops in a flat city and their Voronoi cells 

(http://en.wikipedia.org/wiki/Voronoi\_diagram

考古学 7

Figure 2.4 Voronoi tessellation in a cylinder (Voro++ library:
http://math.lbl.gov/voro++/

考古学,Voronoi图有如下性质: 

l n个点的点集S的Voronoi图至多有2n-5个顶峰和3n-6条边; 

l 每个Voronoi点恰好是三条Voronoi边的交点; 

l 设v是Vor(S)的终端,则圆C(v)内不含S的另外点; 

l 点集S中点Pi的每一个目前邻近点确定V(Pi)的一条边; 

l Voronoi图的直线对偶图是S的一个三角形剖分; 

l
假使Pi,Pj属于S,并且经过Pi,Pj有一个不包含S中任何点的圆,那么线段PiPj是点集S三角剖分的一条边,反之亦建立。 

三、 Delaunay三角剖分 

1. 二维实数域上的三角剖分

假诺V是二维实数域上的有限点集,边e是由点集中的点作端点构成的封闭线段,E为e的联谊,那么该点集V的一个三角形剖分T=(V,E)是一个平面图: 

l 除了端点,平面图中的边不含有点集中的任何点; 

l 没有相交边; 

l 平面图中有所的面都是三角面,且具有三角面的合集是点集V的凸包。 

2. Delaunay边

假使E中的一条边(两端点a,b),e满足下列条件,则称为Delaunay边:存在一个圆经过a,b两点,圆内不带有点集V中的任何的点。这一风味又称作空圆特性。 

3. Delaunay三角剖分

假如点集V的一个三角形剖分T中只包含Delaunay边,那么该三角剖分称为Delaunay剖分。 

不久前点意思下的Voronoi图的对仗图实际上是点集的一种三角剖分,该三角剖分就是Delaunay剖分(表示为DT(S)),其中每个三角形的外接圆不包含点集中的任何任何点。由此,在布局点集的Voronoi图之后,再作其对偶图,即对每条Voronoi边作通过点集中某两点的垂直平分线,即得到Delaunay三角剖分。 

考古学 8

Figure 3.1 Delaunay Triangulation (Generated by MATLAB) 

再看多少个图片,加深对Delaunay三角剖分的了然: 

考古学 9

Figure 3.2 Delaunay Edge  

考古学 10

Figure 3.3 Illustrate Delaunay Edge 

考古学 11

Figure 3.4 Delaunay Edge 

4. Delaunay三角剖分的特性

l
1978年Sibson注脚了在二维的图景下,在点集的拥有三角剖分中,Delaunay三角剖分使得生成的三角的最小角达到最大(max-min
angle)。因为这一特性,对于给定点集的Delaunay三角剖分总是竭尽制止“瘦长”三角形,自动向等边三角形逼近; 

l 局部优化与总体优化(locally optimal and globally optimal); 

l Delaunay空洞(cavity)与部分重连(local reconnection); 

  1. 经文的Delaunay三角剖分算法 

眼下常用的算法分为二种,有扫描线法(Sweepline)、随机增量法(Incremental)、分治法(Divide
and Conquer)等。 

经文的Delaunay三角剖分算法主要有两类:Bowyer/沃特(Wat)son算法和有些变换法。 

l
Bowyer/沃特son算法又叫做Delaunay空洞算法或加点法,以Bowyer和沃特son算法为代表。从一个三角开始,每一次加一个点,保证每一步拿到的近来三角形是有些优化的。以大英帝国Bath高校数学分校Bowyer,格林(Green),Sibson为表示的乘除Dirichlet图的法门属于加点法,是较早成名的算法之一;以澳大华雷斯华沙大学地学系沃特(Wat)son为表示的空外接球法也属于加点法。加点法算法简明,是近来采纳最多的算法,该格局应用了Delaunay空洞性质。Bowyer/沃特son算法的长处是与上空的维数无关,并且算法在落实上比部分变换算法简单。该算法在新点参与到Delaunay网格时,部异常接球包含新点的三角单元不再适合Delaunay属性,则这多少个三角形单元被去除,形成Delaunay空洞,然后算法将新点与重组空洞的每一个终端相连生成一个新边,遵照空球属性可以作证这么些新边都是局部Delaunay的,由此新生成的三角形网格仍是Delaunay的。 

考古学 12

Figure 3.5 Illustration of 2D Bowyer/Watson algorithm for Delaunay
Triangulation 

l
局部变换法又叫做换边、换面法。当使用部分变换法实现增量式点集的Delaunay三角剖分时,首先定位新参加点所在的三角形,然后在网格中投入几个新的连天该三角形顶点与新顶点的边,若该新点位于某条边上,则该边被剔除,四条连接该新点的边被参预。最终,在通过换边方法对该新点的局部区域内的边举行检测和转换,重新维护网格的Delaunay性质。局部变换法的另一个亮点是其得以对已存在的三角形网格举办优化,使其转移成为Delaunay三角网格,该形式的弱项则是当算法扩大到高维空间时变得相比复杂。 

四、 Delaunay三角剖分在OpenCascade的施用

OpenCascade中网格剖分的包紧要有BRepMesh、MeshAlgo、MeshVS,其中,类MeshAlgo_Delaunay使用算法沃特son来开展Delaunay三角剖分。从类StlTransfer中的注释The
triangulation is computed with the Delaunay algorithm implemented in
package
BRepMesh.可以看出包BRepMesh就是Delaunay三角剖分的切实可行落实。使用模式如下: 

BRepMesh::Mesh (aShape, Deflection); 

这多少个函数紧假使用来对拓扑形状举办三角剖分。以下通过将一个圆柱三角剖分为例表达什么将一个拓扑形状举行三角剖分并将结果开展可视化。 

/**
*    Copyright (c) 2013 eryar All Rights Reserved.
*
*        File    : Main.cpp
*        Author  : eryar@163.com
*        Date    : 2013-05-26
*        Version : 0.1
*
*    Description : Use BRepMesh_Delaun class to learn 
*                  Delaunay's triangulation algorithm.
*
*/
// Open Cascade library.
#include <gp_Pnt.hxx>
#include <gp_Pln.hxx>
#include <BRep_Tool.hxx>
#include <TopoDS.hxx>
#include <TopoDS_Edge.hxx>
#include <TopoDS_Wire.hxx>
#include <TopoDS_Face.hxx>
#include <BRepBuilderAPI_MakeEdge.hxx>
#include <BRepBuilderAPI_MakeWire.hxx>
#include <BRepBuilderAPI_MakeFace.hxx>

#include <BRepPrimAPI_MakeBox.hxx>
#include <BRepPrimAPI_MakeCone.hxx>
#include <BRepPrimAPI_MakeCylinder.hxx>
#include <BRepPrimApI_MakeSphere.hxx>

#include <BRepMesh.hxx>
#include <TopExp_Explorer.hxx>
#include <Poly_Triangulation.hxx>
#include <TShort_Array1OfShortReal.hxx>

#pragma comment(lib, "TKernel.lib")
#pragma comment(lib, "TKMath.lib")
#pragma comment(lib, "TKBRep.lib")
#pragma comment(lib, "TKPrim.lib")
#pragma comment(lib, "TKMesh.lib")
#pragma comment(lib, "TKTopAlgo.lib")

// OpenSceneGraph library.
#include <osgDB/ReadFile>
#include <osgViewer/Viewer>
#include <osgViewer/ViewerEventHandlers>
#include <osgGA/StateSetManipulator>

#pragma comment(lib, "osgd.lib")
#pragma comment(lib, "osgDbd.lib")
#pragma comment(lib, "osgGAd.lib")
#pragma comment(lib, "osgViewerd.lib")

osg::Node* BuildShapeMesh(const TopoDS_Shape& aShape)
{
    osg::ref_ptr<osg::Group> root = new osg::Group();
    osg::ref_ptr<osg::Geode> geode = new osg::Geode();
    osg::ref_ptr<osg::Geometry> triGeom = new osg::Geometry();
    osg::ref_ptr<osg::Vec3Array> vertices = new osg::Vec3Array();
    osg::ref_ptr<osg::Vec3Array> normals = new osg::Vec3Array();

    BRepMesh::Mesh(aShape, 1);

    TopExp_Explorer faceExplorer;

    for (faceExplorer.Init(aShape, TopAbs_FACE); faceExplorer.More(); faceExplorer.Next())
    {
        TopLoc_Location loc;
        TopoDS_Face aFace = TopoDS::Face(faceExplorer.Current());

        Handle_Poly_Triangulation triFace = BRep_Tool::Triangulation(aFace, loc);
        Standard_Integer nTriangles = triFace->NbTriangles();

        gp_Pnt vertex1;
        gp_Pnt vertex2;
        gp_Pnt vertex3;

        Standard_Integer nVertexIndex1 = 0;
        Standard_Integer nVertexIndex2 = 0;
        Standard_Integer nVertexIndex3 = 0;

        TColgp_Array1OfPnt nodes(1, triFace->NbNodes());
        Poly_Array1OfTriangle triangles(1, triFace->NbTriangles());

        nodes = triFace->Nodes();
        triangles = triFace->Triangles();       

        for (Standard_Integer i = 1; i <= nTriangles; i++)
        {
            Poly_Triangle aTriangle = triangles.Value(i);

            aTriangle.Get(nVertexIndex1, nVertexIndex2, nVertexIndex3);

            vertex1 = nodes.Value(nVertexIndex1);
            vertex2 = nodes.Value(nVertexIndex2);
            vertex3 = nodes.Value(nVertexIndex3);

            gp_XYZ vector12(vertex2.XYZ() - vertex1.XYZ());
            gp_XYZ vector13(vertex3.XYZ() - vertex1.XYZ());
            gp_XYZ normal = vector12.Crossed(vector13);
            Standard_Real rModulus = normal.Modulus();

            if (rModulus > gp::Resolution())
            {
                normal.Normalize();
            }
            else
            {
                normal.SetCoord(0., 0., 0.);
            }

            vertices->push_back(osg::Vec3(vertex1.X(), vertex1.Y(), vertex1.Z()));
            vertices->push_back(osg::Vec3(vertex2.X(), vertex2.Y(), vertex2.Z()));
            vertices->push_back(osg::Vec3(vertex3.X(), vertex3.Y(), vertex3.Z()));

            normals->push_back(osg::Vec3(normal.X(), normal.Y(), normal.Z()));
        }    
    }

    triGeom->setVertexArray(vertices.get());
    triGeom->addPrimitiveSet(new osg::DrawArrays(osg::PrimitiveSet::TRIANGLES, 0, vertices->size()));

    triGeom->setNormalArray(normals);
    triGeom->setNormalBinding(osg::Geometry::BIND_PER_PRIMITIVE);

    geode->addDrawable(triGeom);

    root->addChild(geode);

    return root.release();
}

int main(int argc, char* argv[])
{
    osgViewer::Viewer myViewer;
    osg::ref_ptr<osg::Group> root = new osg::Group();

    root->addChild(BuildShapeMesh(BRepPrimAPI_MakeCylinder(.6, 1)));

    myViewer.setSceneData(root);

    myViewer.addEventHandler(new osgGA::StateSetManipulator(myViewer.getCamera()->getOrCreateStateSet()));
    myViewer.addEventHandler(new osgViewer::StatsHandler);
    myViewer.addEventHandler(new osgViewer::WindowSizeHandler);

    return myViewer.run();
}

结果如下图所示: 

考古学 13

Figure 4.1 Cylinder mesh generated by BRepMesh::Mesh 

BRepMesh::Mesh是经过包装的,便于对拓扑形状举办三角剖分。以下通过一个简练的例子来验证直接动用BRepMesh_Delaun的方法: 

/**
*    Copyright (c) 2013 eryar All Rights Reserved.
*
*        File    : Main.cpp
*        Author  : eryar@163.com
*        Date    : 2013-05-26
*        Version : 0.1
*
*    Description : Use BRepMesh_Delaun class to learn 
*                  Delaunay's triangulation algorithm.
*
*/

#include <BRepMesh_Edge.hxx>
#include <BRepMesh_Delaun.hxx>
#include <BRepMesh_Array1OfVertexOfDelaun.hxx>
#include <TColStd_MapIteratorOfMapOfInteger.hxx>

#pragma comment(lib, "TKernel.lib")
#pragma comment(lib, "TKMesh.lib")

int main(int argc, char* argv[])
{
    BRepMesh_Array1OfVertexOfDelaun vertices(1, 4);

    vertices.SetValue(1, BRepMesh_Vertex(0, 0, MeshDS_Free));
    vertices.SetValue(2, BRepMesh_Vertex(1, 0, MeshDS_Free));
    vertices.SetValue(3, BRepMesh_Vertex(1, 1, MeshDS_Free));
    vertices.SetValue(4, BRepMesh_Vertex(0, 1, MeshDS_Free));

    BRepMesh_Delaun triangulation(vertices);
    //triangulation.AddVertex(BRepMesh_Vertex(0.5, 0.5, MeshDS_OnSurface));
    Handle_BRepMesh_DataStructureOfDelaun meshData = triangulation.Result();

    std::cout<<"Iterate Mesh Triangles:"<<std::endl;

    MeshDS_MapOfInteger::Iterator triDom;
    for (triDom.Initialize(meshData->ElemOfDomain()); triDom.More(); triDom.Next())
    {
        Standard_Integer triId = triDom.Key();
        const BRepMesh_Triangle& curTri = meshData->GetElement(triId);

        Standard_Integer vertexIndex1 = 0;
        Standard_Integer vertexIndex2 = 0;
        Standard_Integer vertexIndex3 = 0;

        Standard_Integer edgeIndex1 = 0;
        Standard_Integer edgeIndex2 = 0;
        Standard_Integer edgeIndex3 = 0;

        Standard_Boolean o1 = Standard_False;
        Standard_Boolean o2 = Standard_False;
        Standard_Boolean o3 = Standard_False;

        curTri.Edges(edgeIndex1, edgeIndex2, edgeIndex3, o1, o2, o3);

        const BRepMesh_Edge& edge1 = meshData->GetLink(edgeIndex1);
        const BRepMesh_Edge& edge2 = meshData->GetLink(edgeIndex2);
        const BRepMesh_Edge& edge3 = meshData->GetLink(edgeIndex3);

        vertexIndex1 = (o1? edge1.FirstNode(): edge1.LastNode());
        vertexIndex2 = (o1? edge1.LastNode() : edge1.FirstNode());
        vertexIndex3 = (o2? edge2.LastNode() : edge2.FirstNode());

        const BRepMesh_Vertex& vertex1 = meshData->GetNode(vertexIndex1);
        const BRepMesh_Vertex& vertex2 = meshData->GetNode(vertexIndex2);
        const BRepMesh_Vertex& vertex3 = meshData->GetNode(vertexIndex3);

        const gp_XY& p1 = vertex1.Coord();
        const gp_XY& p2 = vertex2.Coord();
        const gp_XY& p3 = vertex3.Coord();

        std::cout<<"--------"<<std::endl;
        std::cout<<p1.X()<<" , "<<p1.Y()<<std::endl;
        std::cout<<p2.X()<<" , "<<p2.Y()<<std::endl;
        std::cout<<p3.X()<<" , "<<p3.Y()<<std::endl;
        std::cout<<"========"<<std::endl;
    }

    return 0;
}

上述顺序是以一个正方形为例,使用BRepMesh_Delaun三角剖分的结果为五个三角,如下所示: 

Iterate Mesh Triangles: 
——– 
1 , 1 
0 , 0 
1 , 0 
======== 
——– 
1 , 1 
0 , 1 
0 , 0 
======== 

 以上结果都是二维空间上的,三维空间中的使用方法可以参考类:BRepMesh_法斯特(Fast)DiscretFace。这几个类表达了如何将一个面拓展网格划分。 

五、 结论

Delaunay三角剖分理论在三维几何样子中如故相比较首要的,通过对造型的三角形剖分,不仅可以对其进展可视化,还有利于对造型做更加的拍卖,如消隐、光照处理等。通过对OpenCascade中三角剖分算法的采纳,以更为询问三角剖分理论应用及其算法实现。 

六、 参考资料

  1. 周培德. 总括几何—算法设计与分析. 厦大大学出版社, 2011 

  2. 李海生. Delaunay三角剖分理论及可视化应用商讨. 泗水外国语高校出版社,
    2010 

  3. 何援军. 总计机图形学. 机械工业出版社, 2010 

  4. 周元峰, 孙峰, 王文平, 汪嘉业, 张彩明.
    基于局部修复的移位多少点Delaunay三角化连忙更新方法.
    总结机帮助设计与图片学学报, 2011, 12: 2006-1012 

  5. http://en.wikipedia.org/wiki/Voronoi_diagram

 

PDF Version: Delaunay Triangulation in
OpenCascade

发表评论

电子邮件地址不会被公开。 必填项已用*标注

网站地图xml地图